struct TransformComponents
{
	vec3 position;
	vec3 scale;
};
struct Transform
{
	TransformComponents components;
};
uniform ModelData
{
	Transform transform;
} model;

#pragma MSP stage(vertex)
layout(location=0) in vec4 position;
void main()
{
	gl_Position = vec4(model.transform.components.position+position.xyz*model.transform.components.scale, 1.0);
}

/* Expected output: vertex
struct TransformComponents
{
	vec3 position;
	vec3 scale;
};
struct Transform
{
	TransformComponents components;
};
layout(binding=26) uniform ModelData
{
	Transform transform;
} model;
layout(location=0) in vec4 position;
void main()
{
	gl_Position = vec4(model.transform.components.position+position.xyz*model.transform.components.scale, 1.0);
}
*/
